define(function(require, exports, module) {
    require("../css/m_bottom_menu.css");
    var getData = require('./getData');

    var bottomMenu = function() {
        var $bottomMenu = null;
        var defaultUpHeight = 170;
        var upHeight = 170;
        var maxHeight = 0;
        var moveH = 0;
        var maxFlag = false;
        var options = {};
        var disabled = false;

        var data = [
            {"name":"自动","centreid":"S000","selected":true,"icon":"./temp/b_icon_01.png"},
            {"name":"急速","centreid":"S001","disabled":true,"icon":"./temp/b_icon_02.png"},
            {"name":"睡眠","centreid":"S002","icon":"./temp/b_icon_03.png"},
            {"name":"风速","centreid":"S003","icon":"./temp/b_icon_04.png"},
            {"name":"定时","centreid":"S004","icon":"./temp/b_icon_01.png"},
            {"name":"童锁","centreid":"S005","icon":"./temp/b_icon_02.png"},
            {"name":"负离子","centreid":"S006","icon":"./temp/b_icon_03.png"},
            {"name":"灯","centreid":"S007","icon":"./temp/b_icon_04.png"}
        ];

        var init = function(dom,appType) {
            options['main'] = $(dom);
            //renderDom(data);
            switchType(data,appType);

            bindTouch();
            
            maxHeight = $('#bottom-menu').height();
            return this;
        };

        var switchType = function(data,appType){
            switch(appType){
                case 0:
                    goAir(data);
                    break;
                case 1:
                    goWasher(data);
                    break;
                case 2:
                    goPurifier(data);
                    break;
                default:
                    break;
            }
        };

        var goAir = function(data){
            var strArr = data.map(function(v,i){
                if(v.selected){
                    return '<li class="bottom-item bottom-air boderbox bottom-air-cur" data-centreid="'+ v.centreid +'">'+ v.name +'</li>';
                }
                return '<li class="bottom-item bottom-air boderbox" data-centreid="'+ v.centreid +'">'+ v.name +'</li>';
            });
            var html = strArr.join('');
            renderDom(html);
        };

        var goWasher = function(data){
            var data = [
                {"centreid":"0","name":"标准","selected":true},
                {"centreid":"8", "name":"快洗"},
                {"centreid":"11", "name":"单脱水"},
                {"centreid":"3", "name":"羊毛"},
                {"centreid":"1", "name":"标准40°"},
                {"centreid":"7", "name":"强力60°"},
                {"centreid":"10", "name":"单漂洗"},
                {"centreid":"4", "name":"羊毛30°"},
                {"centreid":"2", "name":"标准60°"},
                {"centreid":"6", "name":"羽绒30°"},
                {"centreid":"9", "name":"单洗涤"},
                {"centreid":"5", "name":"毛毯30°"}
            ];
            var strArr = data.map(function(v,i){
                if(v.selected){
                    return '<li class="bottom-item bottom-washer boderbox bottom-washer-cur" data-centreid="'+ v.centreid +'"><span>'+ v.name +'</span></li>';
                }
                if(v.disabled){
                    return '<li class="bottom-item bottom-washer boderbox bottom-disabled" data-centreid="'+ v.centreid +'"><span>'+ v.name +'</span></li>';
                }
                return '<li class="bottom-item bottom-washer boderbox" data-centreid="'+ v.centreid +'"><span>'+ v.name +'</span></li>';
            });
            var html = strArr.join('');
            renderDom(html);
            bindItem();
        };

        var goPurifier = function(data){
            var strArr = data.map(function(v,i){
                if(v.selected){
                    return '<li class="bottom-item bottom-purifier boderbox" data-centreid="'+ v.centreid +'">'
                            +'<img class="bottom-icon" src="'+ v.icon +'" alt="icon"><p class="bottom-name">'+ v.name +'</p>'
                          +'</li>';
                }
                return '<li class="bottom-item bottom-purifier boderbox" data-centreid="'+ v.centreid +'">'
                        +'<img class="bottom-icon" src="'+ v.icon +'" alt="icon"><p class="bottom-name">'+ v.name +'</p>'
                      +'</li>';
            });
            var html = strArr.join('');
            renderDom(html,'bottom-purifier-wrapper');
            upHeight = defaultUpHeight = 192;        
        };

        var renderDom = function(html,cusClass) {
            cusClass = cusClass || '';
        	$bottomMenu = $('<div id="bottom-menu" class="bottom-menu '+ cusClass +'">'
				             +'<div id="bottom-pull" class="bottom-pull"></div>'
				             +'<ul class="bottom-list">'
                                + html
				             +'</ul>'
				         +'</div>');

            options['main'].append($bottomMenu);
            options['bottomPull'] = $('#bottom-pull');
            options['bottomPull'].on('touchend',function(){
                !maxFlag ? moveMax() : moveMin();
            })
        };
        var move = function(h) {
            $bottomMenu.css({
                '-webkit-transform': 'translate(0,-' + h + 'px)',
                'transform': 'translate(0,-' + h + 'px)',
                '-webkit-transition': 'none',
                'transition': 'none'
            });
        };
        var moveMax = function() {
            $bottomMenu.css({
                '-webkit-transform': 'translate(0,-' + maxHeight + 'px)',
                'transform': 'translate(0,-' + maxHeight + 'px)',
                '-webkit-transition': '-webkit-transform .2s ease',
                'transition': 'transform .2s ease'
            });
            options['bottomPull'].addClass('bottom-pull-down');
            upHeight = maxHeight;
            maxFlag = true;
            upDown('max');
        };
        var moveMin = function() {
            $bottomMenu.css({
                '-webkit-transform': 'translate(0,-'+ defaultUpHeight +'px)',
                'transform': 'translate(0,-'+ defaultUpHeight +'px)',
                '-webkit-transition': '-webkit-transform .2s ease',
                'transition': 'transform .2s ease'
            });
            options['bottomPull'].removeClass('bottom-pull-down');
            upHeight = defaultUpHeight;
            maxFlag = false;
            upDown('min');
        };
        var startY, moveY, tTime;
        var tStart = function(event) {
            event.preventDefault();
            var touch = event.touches[0];
            startY = touch.pageY;
            moveY = 0;
            tTime = new Date() * 1;
            move(upHeight);
        };
        var tMove = function(event) {
            event.preventDefault();
            if (event.touches.length > 1 || event.scale && event.scale !== 1) return;
            var touch = event.touches[0];
            moveY = parseInt(touch.pageY - startY);
            moveH = upHeight - moveY;
            moveH = moveH >= maxHeight ? maxHeight : moveH;
            if (moveY > 0) {
                if (upHeight <= defaultUpHeight) {
                    return;
                }
            } else if (moveY < 0) {
                if (upHeight >= maxHeight) {
                    return;
                }
            } else {
                return;
            }
            var val = moveY / (maxHeight - defaultUpHeight);
            upDown(val);
            move(moveH);

        };
        var tEnd = function(event) {
            if (maxFlag) {
            	if (moveY > 0) {
                    moveY > 30 ? moveMin() : moveMax();
                } else if (moveY < 0) {
                    return false;
                }
            } else {
                if (moveY > 0) {
                    moveY > 30 ? moveMin() : moveMax();
                } else if (moveY < 0) {
                    moveY < -30 ? moveMax() : moveMin();
                }
            }

        };

        var bindTouch = function() {
            var dom = $bottomMenu.get(0);
            dom.addEventListener('touchstart', tStart, false);
            dom.addEventListener('touchmove', tMove, false);
            dom.addEventListener('touchend', tEnd, false);
            dom.addEventListener('MSPointerDown', tStart);
            dom.addEventListener('pointerdown', tStart);
            dom.addEventListener('MSPointerMove', tMove);
            dom.addEventListener('pointermove', tMove);
            dom.addEventListener('MSPointerUp', tEnd);
            dom.addEventListener('pointerup', tEnd);
        };

        var bindItem = function() {
            $('.bottom-item').on('touchend click', function() {
                if (moveY === 0 && !disabled) {
                    var $that = $(this);
                    var centreid;
                	var i,WashTime,RinseTimes,DehydrationTime,DehydrateSpeed,Temperature;
                    if($that.hasClass('bottom-disabled')) return;
                    $that.addClass('bottom-item-cur').siblings().removeClass('bottom-item-cur');
                    centreid = $that.attr('data-centreid');
                    $("#J-c-edit").attr({"attr-id":centreid});
                    switch(centreid){
	    	        	case '0':
	    	        		i='0';
	    	                break;
	    	        	case '8':
	    	        		i='14';
	    	        		Temperature=null;
	    	                break;
	    	        	case '11':
	    	        		i='22';
	    	        		Temperature=null;
	    	                break;
	    	        	case '1':
	    	        		i='0';
	    	        		Temperature='3';
	    	                break;
	    	        	case '7':
	    	        		i='13';
	    	        		Temperature='5';
	    	                break;
	    	        	case '10':
	    	        		i='21';
	    	        		Temperature=null;
	    	                break;
	    	        	case '4':
	    	        		i='3';
	    	        		Temperature='2';
	    	                break;
	    	        	case '2':
	    	        		i='0';
	    	        		Temperature='5';
	    	                break;
	    	        	case '6':
	    	        		i='7';
	    	        		Temperature='2';
	    	                break;
	    	        	case '9':
	    	        		i='20';
	    	        		Temperature=null;
	    	                break;
	    	        	case '5':
	    	        		i='1';
	    	        		Temperature='2';
	    	                break;
	    	        	case '3':
	    	        		i='3';
	    	                break;
	    	            default:
	    	        		i='0';
	    	                break;
	    	    	}
                    require.async(['../../package/sanyoWasher/js/washerData.js'], function(data) {
                		var arr = data.sanyYangData[centreid]['val'];
                		WashTime= arr[0];
                		RinseTimes= arr[1];
                		DehydrationTime= arr[2];
                		DehydrateSpeed= arr[3];
                		
                		Start=true;
                		if(Start){
                			//中心圆圈渲染
                			//CmdProcessFn(num,Temperature);
                			CmdProcessFn(i,WashTime,RinseTimes,DehydrationTime,DehydrateSpeed,Temperature);
                		}
                	});
                }
            })
        };
        
      //程序选择
      function CmdProcessFn(i,WashTime,RinseTimes,DehydrationTime,DehydrateSpeed,Temperature){
        	var cmd;
        	var wStr='';
        	var rStr='';
        	var dStr='';
        	var deStr='';
        	var tStr='';
        	if(WashTime !== null){ wStr=',{"state": "WashTime","value": "'+WashTime+'"}'; }
        	
        	if(RinseTimes !== null){ rStr=',{"state": "RinseTimes","value": "'+RinseTimes+'"}'; }
        	
        	if(DehydrationTime !== null){ dStr=',{"state": "DehydrationTime","value": "'+DehydrationTime+'"}'; }
        	
        	if(DehydrateSpeed !== null){ deStr=',{"state": "WashTime","value": "'+DehydrateSpeed+'"}'; }
        	
        	if(Temperature !== null){ tStr=',{"state": "WashTime","value": "'+Temperature+'"}'; }
        	
        	//cmd='{"modId":"'+modId+'","stateSet":[{"state": "Program","value": "'+i+'"}'+wStr+rStr+dStr+deStr+tStr+']}';
        	
        	cmd='{"modId":"'+modId+'","stateSet":[{"state": "Program","value": "'+i+'"}]}';

        	//cmd=JSON.stringify(cmd);
        	var params={"userId":userId,"cmd":cmd,"mcId":mcId};
        	params=JSON.stringify(params);
        	var signStr;
        	
        	getData.gGetSign('?params='+params,function(data){
        		if(data.data){
        			signStr=data.data;
        			
        			//发送开机命令
        			var param = {
                        "userId": userId,
                        "mcId": mcId,
                        "cmd": cmd,
						"deviceId":deviceId,
                        //"modelType":"1",//型号类别，0自主产品，1第三方产品、非空
                        "sign":signStr    //加密参数(userId + deviceId  + cmd + mcId) ,非空
                    };
            		
                    getData.gExecuteCmd(param,function(data){
                        if(data.ret === "0"){
                        	//可以启动
                        }else{
                        	//无法启动
                        	gFuncObj.gErrorTips("调整失败！");
                        	setTimeout(function(){
                        		if(gFuncObj.objStatus){
                        			gFuncObj.gDrawMain(gFuncObj.objStatus);
                        		}
                        	},15000);
                        }
                    });

        		}
        	});
        }

        var upDown = function(bool){};
        var bindCentreShow = function(callback){
            upDown = function(bool){
                if (callback && typeof(callback) === 'function') {
                    callback(bool);
                }
            }
        };

        $(document).on('touchend',function(){
            return;
        });

        var isDisable = function(bool){
            disabled = bool === true ? true : false;
        };

        return {
            init: init,
            bindItem: bindItem,
            bindCentreShow: bindCentreShow,
            isDisable: isDisable
        }
    }

    return new bottomMenu;
});
