/* 中间部分内容加载 */
define(function(require, exports, module) {
    var colorSelector = require('./colorSelector');
    var menu = require('./menu')


    var gFunc = function() {

        //开机初始化数据请求方法
        function gBootRequest() {
            var ReturnName;
            var url = host + '/api/device/jsonp/queryMcInfo?mcId=' + mcId + '&userId=' + userId;
            $.ajax({
                type: "GET",
                url: url,
                dataType: "jsonp",
                timeout: 20000,
                success: function(data) {
                    //console.log(data);
                    if (data.ret === '0') {
                        if (data.data.mcAlias) {
                            ReturnName = data.data.mcAlias;
                        } else {
                            ReturnName = data.data.mcName;
                        }
                        //公用运行的设备名称
                        gFuncObj.gMcName = ReturnName;

                        //设备名称
                        $("#mcName").html(ReturnName);

                        if (data.data.status) {
                            var status = eval("(" + data.data.status + ")");

                            gFuncObj.objStatus = status;

                            java2js("", status);
                        }
                    } else {
                        gErrorTips("设备不存在!");
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    gErrorTips("设备连接失败！");
                }
            });
        }

        //渲染面板,接受推送
        function java2js(cmd, obj) {
            //alert(cmd+"--"+obj);
            if (cmd != "shareControl") {
                if (obj) {
                    if (typeof(obj) === 'string') {
                        obj = eval("(" + obj + ")");
                    }
                } else {
                    return;
                }
            }

            //console.log(JSON.parse(obj));

            if (cmd) {
                switch (cmd) {
                    case "intiParam": //插件获取初始化参数
                        isApp = obj.isApp;
                        mcId = obj.mcId;
                        userId = obj.userId;
                        userName = obj.userName;
                        deviceId = obj.deviceId;
                        modelId = obj.modelId;
                        modId = obj.modelId;
                        break;
                    case "startStateChanged": //主动请求获取设备状态&接受推送
                        allDraw(obj);
                        break;
                    case "cmd": //发送请求
                        allDraw(obj);
                        break;
                    case "modifyDeviceName": //修改设备昵称
                        if (obj) {
                            //修改成功
                            require.async(['./util/alert/sweetalert.min', '../css/sweetalert.css'], function(sweetalert) {
                                var $mcName = $('#mcName');
                                $mcName.html(gFuncObj.gMcName);
                                swal("设备名称修改成功！");
                            });

                        } else {
                            //修改失败
                            gErrorTips("设备昵称修改失败!");
                        }
                        break;
                    case "getDeviceDetail": //获取用户详情
                        if (obj) {
                            //获取用户详情成功
                            require.async('../../../base/js/details', function(DDetails) {
                                DDetails.setHtml('#content').handleData(obj);
                            });
                        } else {
                            //获取用户详情失败
                            gErrorTips("获取设备详情失败!");
                        }
                        break;
                    case "shareControl": //分享控制权
                        if (obj) {
                            //获取URL成功
                            require.async(['../../../base/js/util/alert/sweetalert.min', '../../../base/js/util/qrcode/qrcode', '../../../base/css/sweetalert.css'], function(sweetalert, QRCODE) {
                                var qrcodeHtml = '<div id="qrcode" class="qrcode"></div>';

                                sweetalert({
                                    title: "分享控制权",
                                    text: qrcodeHtml + "<span>点击&quot;+&quot;添加设备，扫描此二维码，即可自动添加此设备</span>",
                                    html: true
                                });
                                QRCODE.qrcode($('#' + $(qrcodeHtml)[0].id), {
                                    width: 305,
                                    height: 305,
                                    correctLevel: QRCODE.QRErrorCorrectLevel.L,
                                    background: "#ffffff",
                                    foreground: "#000000",
                                    text: obj
                                });
                            });
                        } else {
                            //获取用户详情失败
                            gErrorTips("获取设备详情失败!");
                        }
                        break;
                    case "deleteDevice": //删除设备
                        if (obj) {
                            //删除设备成功
                            require.async(['./util/alert/sweetalert.min', '../css/sweetalert.css'], function(sweetalert) {
                                swal("删除成功！");
                            });
                        } else {
                            //删除设备失败
                            gErrorTips("删除设备失败!");
                        }
                        break;
                    default:
                        break;
                }
            } else {
                gFuncObj.objStatus = obj;
                allDraw(obj);
            }

            function allDraw(obj) {
                var bright; //亮度  0-255
                var colorTemp; //颜色  ff0000
                var stateSetObj = {}; //stateSet生成对象

                //转换obj
                obj.stateSet.forEach(function(o, i) {
                    stateSetObj[o.state] = o.value;
                });

                //按钮区域
                menu.init(stateSetObj);

                var $obj = $("#main");
                var $oBlock = $obj.find(".pic-block");
                var $oColor = $obj.find(".pic-color");
                var $oTM = $obj.find("#J-pic-txt");
                var tHtml;

                function sTime(ms) {
                    var time = parseFloat(ms) / 1000;
                    if (null != time && "" != time) {
                        if (time > 60 && time < 60 * 60) {
                            time = parseInt(time / 60.0) + ":" + parseInt((parseFloat(time / 60.0) - parseInt(time / 60.0)) * 60);
                        } else if (time >= 60 * 60 && time < 60 * 60 * 24) {
                            time = parseInt(time / 3600.0) + ":" + parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) + ":" + parseInt((parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) - parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) * 60);
                        } else if (time >= 60 * 60 * 24 && time < 60 * 60 * 24 * 30) {
                            time = parseInt(time / 3600.0 / 24.0) + ":" + parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 24) + ":" + parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) + ":" + parseInt((parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) - parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) * 60);
                        } else {
                            time = parseInt(time);
                        }
                    } else {
                        time = "0:0:0";
                    }
                    return time;
                }

                gFuncObj.deviceSwitch = stateSetObj.deviceSwitch;

                //添加选择器
                if (stateSetObj.deviceSwitch === '1') { //开机
                    var color = "#" + stateSetObj.colorTemp;
                    var iB = iB = 0.3 - Math.ceil(stateSetObj.bright * 30 / 255) / 100; //0-255    0.3-0

                    $oBlock.css({
                        "opacity": iB
                    });
                    $oColor.css({
                        "background-color": color,
                        "opacity": "0.4"
                    });

                    if (stateSetObj.timeOn) {
                        if (stateSetObj.timeOn != "0") {
                            var time1 = sTime(653232);
                            tHtml = '<span class="time">开灯时间：' + time1 + '</span>';
                        }
                    }

                    if (stateSetObj.timeOff) {
                        if (stateSetObj.timeOff != "0") {
                            var time2 = sTime(432345);
                            tHtml = '<span class="time">关灯时间：' + time2 + '</span>';
                        }
                    }

                    if (stateSetObj.mode == "2") { //炫彩模式
                        tHtml += '<span class="color-light">炫彩时间：</span>';
                    }

                    $oTM.append(tHtml);

                    //选择器
                    bright = stateSetObj.bright;
                    colorTemp = stateSetObj.colorTemp;
                    colorSelector.init(bright, colorTemp).getSwitch(true);
                } else { //关机
                    $oBlock.css({
                        "opacity": "0"
                    });
                    $oColor.css({
                        "background-color": "#7e7e7e",
                        "opacity": "0.5"
                    });

                    colorSelector.getSwitch(false);
                }


                //房间区域
                /*room(iLight,iColor);

                //按钮区域
                room(iLight,iColor);*/

            }
        }

        //报错提示
        function gErrorTips(str) {
            var html = '<div class="g-e-tips"><p>' + str + '</p></div>';
            if ($(".g-e-tips").length == 0) {
                $("body").append(html);
            } else {
                $(".g-e-tips").find("p").html(str);
            }
            setTimeout(function() {
                $(".g-e-tips").remove();
            }, 1000);
        }

        //请求回调
        function gCallBack() {

        }

        return {
            gBootRequest: gBootRequest,
            java2js: java2js,
            gErrorTips: gErrorTips
        };

    };

    return new gFunc;
});
