define(function(require, exports, module) {
    require('../css/m_menu.css');
    var bottomTime = require('../../../base/js/bottomTime');
    var bottomLayer = require('../../../base/js/bottomLayer');
    var getData = require('../../../base/js/getData');

    var disabled = true;        //开关灯状态 true 关灯 false 开灯
    var timeText = '定时开灯';
    var timeText2 = '开灯时间';
    var timeType = null;
    var timeType2 = null;
    var curMenuId = null;       //当前色温+亮度
    var timeOn = 0;
    var timeOff = 0;
    var oldHours = null;
    var oldMinutes = null;

    var tNow = null;
    var date = null;
    var times = null;

    var timeIntervalS = null;
    var timeIntervalMs = null;

    //第一次上报颜色后设置为 false 等第一次推送成功之后才设置成 true 方便后面亮度的推送维持状态
    var isOK = true;
    var newBright = null;

    var $bMenu = $('#b-menu');
    var $bTip = $('#b-tip');
    var $item = null;
    var $tMenu = null;


    //test数据
    /*var stateObj1 = {
        'deviceSwitch' : '1',    // 1 0开关机
        'bright' : '80',         // 灯亮度 0~255
        'colorTemp' : '#33333',  // 灯色温 000000~ffffff
        'timeInterval' : '1200',    // 0~60000ms 炫彩调节时间间隔
        'mode' : '1',            // 1普通 2炫彩 模式
        'timeOn' : '100',        // 0~86400s 定时开
        'timeOff' : '0'        // 0~86400s 定时关
    };*/

    //创建dom节点并绑定事件
    var zero = function(){
        render();
        bindTouch();
        bindItem();
        bindTime();
        bindColorful();
    };

    //初始化
    var init = function(stateObj){

        tNow = new Date();
        initTime(stateObj);

        if(!isOK){
            isOK = true;
            return;
        }
        initStatus(stateObj);
        switchText();
        refresh();
    };

    //初始化时间
    var initTime = function(stateObj){
        var deviceSwitch = stateObj.deviceSwitch;
        var timeInterval = parseInt(stateObj.timeInterval) || 0;

        disabled = deviceSwitch === '1' ? false : true;
        timeText = deviceSwitch === '1' ? '定时关灯' : '定时开灯';
        timeText2 = deviceSwitch === '1' ? '关灯时间' : '开灯时间';

        timeOn = parseInt(stateObj.timeOn) || 0;
        timeOff = parseInt(stateObj.timeOff) || 0;

        if(timeOff === 0 && timeOn === 0){
            times = null;
            $bTipTime.addClass('hide');
        }else{
            getTimes();
            $bTipText.text(timeText2);
            $bTipTimes.text(times);
            $bTipTime.removeClass('hide');
        }

        if(timeInterval){
            $bTipColorful.removeClass('hide');
            timeIntervalS = parseInt(timeInterval/1000);
            timeIntervalS = timeIntervalS > 10 ? (timeIntervalS + '') : ('0' + timeIntervalS);
            timeIntervalMs = timeInterval%1000 + '';
            $bTipSeconds.text(timeIntervalS);
            $bTipMsec.text(timeIntervalMs);
        }else{
            $bTipColorful.add('hide');
        }

        if(!(timeOff === 0 && timeOn === 0) && timeInterval){
            $bTip.removeClass('center').addClass('justify');
        }else{
            $bTip.removeClass('justify').addClass('center');
        }

        
    };

    //转换定时时间格式
    var getTimes = function(){
        
        timeType2 = timeOff ? 'timeOff' : 'timeOn';
        var delay = timeOff ? timeOff : timeOn;
        var tDate1 = tNow.getDate();
        var tTime = tNow*1 + delay*1000;
        var tFuture = new Date(tTime);
        var tDate2 = tFuture.getDate();

        var hours = tFuture.getHours();
        var minutes = tFuture.getMinutes();
        hours = hours < 10 ? ('0' + hours) : hours;
        minutes = minutes < 10 ? ('0' + minutes) : minutes;

        date = tDate1 === tDate2 ? '今天' : '明天';
        times = hours + ':' + minutes;
    };

    //初始化状态
    var initStatus = function(stateObj){
        
        var bright = stateObj.bright;
        var colorTemp = stateObj.colorTemp;        
        var mode = stateObj.mode;
        
        //mode 1 普通模式 2 炫彩模式
        curMenuId = mode === '2' ? '2' : (colorTemp + '|' + bright);
    };

    //刷新dom
    var refresh = function(){
        disabled ? disable() : enable();
        if(timeOn === 0 && timeOn === 0){
            $tMenu.removeClass('b-time-on');
        }else{
            $tMenu.addClass('b-time-on');
        }
    };

    //切换定时按钮文字
    var switchText = function(){
        $tMenu.find('.b-style').text(timeText);
    };

    //关灯
    var disable = function(){
        $bMenu.addClass('b-disabled');
        $('.b-on').removeClass('b-on');
    };

    //开灯
    var enable = function(){
        $bMenu.removeClass('b-disabled');
        $('.b-on').removeClass('b-on');
        $(".b-item[data-sid = '"+ curMenuId +"']").addClass('b-on');     
    };

    //渲染dom
    var render = function(){
        //状态显示
        $bTip.append('<div class="b-tip-time hide">'+
                        '<span class="b-tip-text"></span>:<span class="b-tip-times"></span>'+
                     '</div>'+
                     '<a href="javascript:;" class="b-tip-colorful hide">'+
                        '炫彩时间:<span class="b-tip-seconds"></span>s<span class="b-tip-msec"></span>ms<span class="b-tip-right">></span>'+
                     '</a>');

        var $menu = $('<ul class="b-list justify">'+
                        '<li class="b-item" data-sid="ff0000|80">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">默认</p>'+
                        '</li>'+
                        '<li class="b-item" data-sid="ff00b6|70">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">日光</p>'+
                       '</li>'+
                        '<li class="b-item" data-sid="2400ff|60">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">看书</p>'+
                        '</li>'+
                        '<li class="b-item" data-sid="00ecff|50">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">浪漫</p>'+
                        '</li>'+
                    '</ul>'+
                    '<ul class="b-list justify">'+
                        '<li class="b-item" data-sid="00ff48|40">'+
                           '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">影院</p>'+
                        '</li>'+
                        '<li class="b-item" data-sid="2">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">炫彩</p>'+
                        '</li>'+
                        '<li class="b-item b-time">'+
                            '<a class="b-circle center" href="javascript:;">'+
                                '<span class="b-icon"></span>'+
                            '</a>'+
                            '<p class="b-style">定时开灯</p>'+
                        '</li>'+
                        '<li class="justify-fix"></li>'+
                    '</ul>');

        $bMenu.append($menu);
        $item = $('.b-item');
        $tMenu = $('.b-time');

        $bTipText = $('.b-tip-text');
        $bTipTime = $('.b-tip-time');
        $bTipTimes = $('.b-tip-times');

        $bTipSeconds = $('.b-tip-seconds');
        $bTipMsec = $('.b-tip-msec');
        $bTipColorful = $('.b-tip-colorful');

    };

    //触摸防手滑
    var eventData = {
        startX : 0,
        startY : 0,
        moveX : 0,
        moveY : 0
    };
    var tStart = function(event){
        event.preventDefault();
        var touch = event.touches[0];
        eventData.startX = touch.pageX;
        eventData.startY = touch.pageY;
        eventData.moveX = 0;
        eventData.moveY = 0;
    };
    var tMove = function(event){
        event.preventDefault();
        if (event.touches.length > 1 || event.scale && event.scale !== 1) return;
        var touch = event.touches[0];
        eventData.moveX = parseInt(touch.pageX - eventData.startX);
        eventData.moveY = parseInt(touch.pageY - eventData.startY);
    };
    var tEnd = function(event){};
    var bindTouch = function() {
        var dom = $bMenu.get(0);
        dom.addEventListener('touchstart', tStart, false);
        dom.addEventListener('touchmove', tMove, false);
        dom.addEventListener('touchend', tEnd, false);
        dom.addEventListener('MSPointerDown', tStart);
        dom.addEventListener('pointerdown', tStart);
        dom.addEventListener('MSPointerMove', tMove);
        dom.addEventListener('pointermove', tMove);
        dom.addEventListener('MSPointerUp', tEnd);
        dom.addEventListener('pointerup', tEnd);
    };

    //按钮事件回滚回调函数
    var itemBack = function(){
        $('.b-on').removeClass('b-on');
        $(".b-item[data-sid = '"+ curMenuId +"']").addClass('b-on');
    };

    var okFunc = function(){
        //第二次上报亮度
        postAction('bright', newBright);
    };

    //绑定灯光模式按钮事件
    var bindItem = function() {
        $item.on('touchend', function(){
            var that = $(this);            
            if(!disabled && eventData.moveX === 0 && eventData.moveY === 0 && !that.hasClass('b-on') && !that.hasClass('b-time')){
                $('.b-on').removeClass('b-on');
                that.addClass('b-on');

                var _sid = that.attr('data-sid')+'';

                //炫彩模式
                if(_sid === '2'){
                    postAction('mode', '2', itemBack);
                    return;
                }

                var _sidArr = _sid.split('|');
                var _colorTemp =  _sidArr[0];
                var _bright = _sidArr[1];

                newBright = _bright;

                //灯光模式数据上报
                isOK = false;
                //第一次上报颜色
                postAction('colorTemp', _colorTemp, itemBack, okFunc);
                
            }
        });
    };

    var tBack = function(){
        $tMenu.toggleClass('b-time-on');
    };

    //设置定时回调函数
    var tCallback = function(el,data){
        //console.log(data);

        if(timeType === 'timeOff' && disabled){
            gErrorTips('设备已关灯');
            return;
        }
        if(timeType === 'timeOn' && !disabled){
            gErrorTips('设备已开灯');
            return;
        }

        $tMenu.addClass('b-time-on');

        var tOld = new Date();
        var oldHours = tOld.getHours();
        var oldMinutes = tOld.getMinutes();
        var oldSeconds = tOld.getSeconds();
        var oldTime = parseInt(oldHours)*3600 + parseInt(oldMinutes)*60 + parseInt(oldSeconds);
        var newTime = parseInt(data.one)*3600 + parseInt(data.two)*60;
        var time = newTime >= oldTime ? (newTime - oldTime + '') : (86400 + oldTime - newTime + '');
        //上报定时数据
        postAction(timeType,time,tBack);
    };

    //报错提示
    function gErrorTips(str) {
        var html = '<div class="g-e-tips"><p>' + str + '</p></div>';
        if ($(".g-e-tips").length == 0) {
            $("body").append(html);
        } else {
            $(".g-e-tips").find("p").html(str);
        }
        setTimeout(function() {
            $(".g-e-tips").remove();
        }, 1000);
    };


    var timeBack = function(){
        $tMenu.toggleClass('b-time-on');
    };

    var closeTime = function(){
        $tMenu.removeClass('b-time-on');
        if(timeOff === 0 && timeOn === 0){
            return;
        }
        if(timeType2 === 'timeOff' && disabled){
            gErrorTips('设备已关灯');
            return;
        }
        if(timeType2 === 'timeOn' && !disabled){
            gErrorTips('设备已开灯');
            return;
        }

        
        //上报取消定时数据
        postAction(timeType2,'0',tBack);
    };    

    //绑定定时按钮事件
    var bindTime = function() {
        $tMenu.on('touchend', function(){            
            if(eventData.moveX === 0 && eventData.moveY === 0){
                var that = $(this);                
                
                //定时
                if(timeOff === 0 && timeOn === 0){
                    //that.addClass('b-time-on');
                    //gErrorTips('设备已开灯');
                    var tOld = new Date();
                    oldHours = tOld.getHours();
                    oldMinutes = tOld.getMinutes();
                    oldHours = oldHours < 10 ? ('0' + oldHours) : (oldHours + '');
                    oldMinutes = oldMinutes < 10 ? ('0' + oldMinutes) : (oldMinutes + '');
                    timeType = disabled ? 'timeOn' : 'timeOff';

                    bottomTime.init({
                        title: timeText,
                        cancelFun: true,
                        confirmFun: tCallback,
                        type: 2, //选择器种类
                        curVal: {
                            "one": oldHours,
                            "two": oldMinutes
                        },
                        unit: {
                            "one": null,
                            "two": null
                        },
                        data: null,
                        el: null
                    });
                }else{
                    var html = '<div class="b-timing-wraper"><div class="b-timing">'+ times +'</div>'+
                           '<p class="b-date"><span class="b-text-color">'+ timeText2 +'</span><span class="b-date-color">'+ date +'</span></p></div>';
                    bottomLayer.init({
                        title : timeText,
                        html : html,
                        rightText : '关闭定时',
                        cancelFun : true,
                        confirmFun : closeTime
                    });
                }
            }
        });
    };

    //上报炫彩时间间隔
    var setColorful = function(el,data){
        //console.log(data);
        var itv = parseInt(data.one)*1000 + parseInt(data.two) + '';
        postAction('timeInterval', itv);
    };

    //炫彩模式选择ms
    var bindColorful = function(){

        var data = {
            'one' : ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59"],
            'two' : ['100','200','300','400','500','600','700','800','900']
        };

        $bTipColorful.on('click', function(){
            bottomTime.init({
                title: '时间间隔',
                cancelFun: true,
                confirmFun: setColorful,
                type: 4, //选择器种类
                curVal: {
                    "one": timeIntervalS,
                    "two": timeIntervalMs
                },
                unit: {
                    "one": 's',
                    "two": 'ms'
                },
                data: data,
                el: null
            });
        });
    };

    //提交控制中心
    var postAction = function(state,value,backFunc,okFunc) {
        //console.log(state,value);
        var cmd= {"modId":modId,"stateSet":[{"state": state,"value": value}]};

        getData.getExecuteCmd(cmd ,function(data){
            if(data.ret === "0"){
                //数据提交成功
                if(typeof(okFunc) === 'function'){
                    okFunc();
                }
            }else{
                //数据提交异常
                gFuncObj.gErrorTips("服务器处理异常！");
                if(typeof(backFunc) === 'function'){
                    backFunc();
                }
            }
        });

    };

    zero();
    exports.init = init;

    //test
    //init(stateObj);
    /*setTimeout(function(){
        init(stateObj);
    }, 30000);*/

});