define(function(require, exports, module) {
	require("../css/m_bottom_layer.css");

	var $bottomLayer = $();
	var $bottomBg = $();
	var timer;
	var init = function(option){
		var title = option.title,
			extra = option.extra || '',
			html = option.html,
			leftText = option.leftText || '取消',
			rightText = option.rightText || '确定',
			cancelFun = option.cancelFun,
			confirmFun = option.confirmFun;
		renderDom(title,html,leftText,rightText,cancelFun,confirmFun,extra);
	};
	var renderDom = function(title,html,leftText,rightText,cancelFun,confirmFun,extra){
		distroy();
		var cancelHtml =  cancelFun ? '<a class="bottom-cancel" id="bottom-cancel" href="javascript:;">'+ leftText +'</a>' : '',
			confirmHtml =  confirmFun ? '<a class="bottom-confirm" id="bottom-confirm" href="javascript:;">' + rightText + '</a>' : '';
		$bottomLayer = $('<div class="bottom-bg"></div><div id="bottom-layer" class="bottom-layer">'
		                    +'<div class="bottom-nav flex">'
		                        +'<div class="bottom-btn-left">'+ cancelHtml +'</div>'
		                        +'<div class="bottom-title">'+ title +'</div>'
		                        +'<div class="bottom-btn-right">'+ confirmHtml +'</div>'
		                    +'</div>'
		                    + extra
		                    +'<div id="bottom-module-wrapper" class="bottom-module-wrapper flex">'+ html +'</div>'
		                +'</div>');
		$('#content').append($bottomLayer);
		$bottomBg = $('.bottom-bg');
		$('#bottom-cancel').off('click').on('click',function(){
			if(typeof(cancelFun) === 'function'){
				cancelFun();
			}
			hide();
		});
		$('#bottom-confirm').off('click').on('click',function(){
			if(typeof(confirmFun) === 'function'){
				confirmFun();
			}
			hide();
		});
		$bottomLayer.offset();
		show();
		bindHide();
	};
	var show = function(){
		$bottomBg.addClass('bottom-fade-in');
		$bottomLayer.addClass('bottom-layer-show');
	};
	var hide = function(){
		$bottomBg.addClass('bottom-fade-out');
		$bottomLayer.removeClass('bottom-layer-show');
		clearTimeout(timer);
		timer = setTimeout(function(){
			distroy();
		},300);
	};
	var distroy = function(){
		$bottomLayer.remove();
	};

	var bindHide = function(){
		$bottomBg.on('click',function(){
			hide();
		});
	};	

	module.exports = {
		init : init,
		show : show,
		hide : hide
	}
});