define(function(require, exports, module) {
    require("../css/m_time_off.css");
    var bottomLayer = require('./bottomLayer');
    var iScroll = require('./util/iscroll/iscroll');

    var indexResult = {};
    var scrollBox = {};

    var init = function(options){
        options = {
            title: options.title || '标题',
            cancelFun: options.cancelFun || true,
            confirmFun: options.confirmFun || true,
            type: options.type || 1,
            curVal: options.curVal,
            unit : options.unit,
            data : options.data,
            el: options.el || '',
            extra: options.extra
        };
        renderDom(options);
    };

    var getDom = function(options,idNum){
        var data = options.data[idNum];
        var curVal = options.curVal[idNum];

        var unit = options.unit[idNum];
        var unit1 = unit ? '<span class="bottom-unit"></span>' : '';
        var unit2 = unit ? '<span class="bottom-unit">' + unit + '</span>' : '';
        var con = '';
        var strArr = data.map(function(item,index){
            con = '<span class="bottom-con">'+ item +'</span>' + unit1;
            if(item === curVal){
                return '<li class="bottom-module-hour flex bottom-module-selected">'+ con +'</li>';
            }else{
                return '<li class="bottom-module-hour flex">'+ con +'</li>';
            }
        });
        var html = '<div id="bottom-module-swicth-'+ idNum +'" class="bottom-module-swicth">'
                        +'<div class="bottom-module-choice flex"><span class="bottom-con"></span>'+ unit2 +'</div>'
                        +'<div id="bottom-module-wrapper-'+ idNum +'">'
                            +'<ul id="bottom-module-cylinder-'+ idNum +'" class="bottom-module-cylinder">'
                                +strArr.join('')
                            +'</ul>'
                            +'<div class="bottom-mask"></div>'
                        +'</div>'
                    +'</div>';

        return html;

    };

    var getOneDom = function(options,idNum){
        var data = options.data[idNum];
        var curVal = options.curVal[idNum];

        var strArr = data.map(function(item,index){
            if(item === curVal){
                return '<li class="bottom-module-hour bottom-module-selected">'+ item +'</li>';
            }else{
                return '<li class="bottom-module-hour">'+ item +'</li>';
            }
        });
        var html = '<div id="bottom-module-swicth-'+ idNum +'" class="bottom-module-swicth">'
                        +'<div class="bottom-module-choice"></div>'
                        +'<div id="bottom-module-wrapper-'+ idNum +'">'
                            +'<ul id="bottom-module-cylinder-'+ idNum +'" class="bottom-module-cylinder">'
                                +strArr.join('')
                            +'</ul>'
                            +'<div class="bottom-mask"></div>'
                        +'</div>'
                    +'</div>';

        return html;

    };    

    var timeArr = ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59"];
    var hoursArr = ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23"];

    var renderDom = function(options){
        var type = options.type || 1;
            switch(type){
                case 1:
                    goOneTime(options);
                    break;
                case 2:
                    goTwoTimes(options);
                    break;
                case 3:
                    //无单位单列居中
                    goOne(options);
                    break;
                case 4:
                    //带单位双列
                    goFour(options);
                    break;
                case 5:
                    units = null;
                    break;
                default:
                    break;
            }

    };

    var goOneTime = function(options){
        options.data = options.data || {"one":timeArr};
        options.unit = options.unit || {"one":""};
        options.curVal = options.curVal || {"one":options.data['one'][0]};        
        if(typeof(options.confirmFun) === 'function'){
            options.confirmFun = getResult(options.el,options.confirmFun,options.data);
        };

        options.html = getDom(options,'one');
        bottomLayer.init(options);

        var boxH = $('.bottom-module-swicth').eq(0).height();
        var liHeight = $('.bottom-module-hour').eq(0).height();
        var halfHeight = $('.bottom-module-choice').eq(0).position().top;

        var _indexOne =  options.data["one"].indexOf(options.curVal["one"]);
        var curIndexOne =  _indexOne !== -1 ? _indexOne : 0;        
        var dataLenOne = options.data["one"].length;
        var maxHeightOne = dataLenOne*liHeight;
        var ulHeightOne = maxHeightOne + boxH - liHeight;

        indexResult = {"one":curIndexOne};
        defaultPos('one',ulHeightOne,halfHeight);
        initScroll('one',curIndexOne,liHeight);
    };
    var goTwoTimes = function(options){
        options.data = options.data || {"one":hoursArr,"two":timeArr};
        options.unit = {"one":"","two":""};
        options.curVal = options.curVal || {"one":options.data['one'][0],"two":options.data['two'][0]};        
        if(typeof(options.confirmFun) === 'function'){
            options.confirmFun = getResult(options.el,options.confirmFun,options.data);
        };

        options.html = getDom(options,'one') + getDom(options,'two');
        bottomLayer.init(options);
        twoTimesStyle();

        var boxH = $('.bottom-module-swicth').eq(0).height();
        var liHeight = $('.bottom-module-hour').eq(0).height();
        var halfHeight = $('.bottom-module-choice').eq(0).position().top;

        var _indexOne =  options.data["one"].indexOf(options.curVal["one"]);
        var curIndexOne =  _indexOne !== -1 ? _indexOne : 0;
        var dataLenOne = options.data["one"].length;
        var maxHeightOne = dataLenOne*liHeight;
        var ulHeightOne = maxHeightOne + boxH - liHeight;

        defaultPos('one',ulHeightOne,halfHeight);
        initScroll('one',curIndexOne,liHeight);

        var _indexTwo =  options.data["two"].indexOf(options.curVal["two"]);
        var curIndexTwo =  _indexTwo !== -1 ? _indexTwo : 0;
        var dataLenTwo = options.data["two"].length;
        var maxHeightTwo = dataLenTwo*liHeight;
        var ulHeightTwo = maxHeightTwo + boxH - liHeight;

        indexResult = {"one":curIndexOne,"two":curIndexTwo};
        defaultPos('two',ulHeightTwo,halfHeight);
        initScroll('two',curIndexTwo,liHeight);
    };

    var goOne = function(options){
        options.data = options.data || {"one":timeArr};
        options.unit = options.unit || {"one":""};
        options.curVal = options.curVal || {"one":options.data['one'][0]};        
        if(typeof(options.confirmFun) === 'function'){
            options.confirmFun = getResult(options.el,options.confirmFun,options.data);
        };

        options.html = getOneDom(options,'one');
        bottomLayer.init(options);

        var boxH = $('.bottom-module-swicth').eq(0).height();
        var liHeight = $('.bottom-module-hour').eq(0).height();
        var halfHeight = $('.bottom-module-choice').eq(0).position().top;

        var _indexOne =  options.data["one"].indexOf(options.curVal["one"]);
        var curIndexOne =  _indexOne !== -1 ? _indexOne : 0;        
        var dataLenOne = options.data["one"].length;
        var maxHeightOne = dataLenOne*liHeight;
        var ulHeightOne = maxHeightOne + boxH - liHeight;

        indexResult = {"one":curIndexOne};
        defaultPos('one',ulHeightOne,halfHeight);
        initScroll('one',curIndexOne,liHeight);
    };

    var goFour = function(options){
        options.data = options.data || {"one":hoursArr,"two":timeArr};
        options.unit = options.unit || {"one":"","two":""};
        options.curVal = options.curVal || {"one":options.data['one'][0],"two":options.data['two'][0]};        
        if(typeof(options.confirmFun) === 'function'){
            options.confirmFun = getResult(options.el,options.confirmFun,options.data);
        };

        options.html = getDom(options,'one') + getDom(options,'two');
        bottomLayer.init(options);
        fourTimesStyle();

        var boxH = $('.bottom-module-swicth').eq(0).height();
        var liHeight = $('.bottom-module-hour').eq(0).height();
        var halfHeight = $('.bottom-module-choice').eq(0).position().top;

        var _indexOne =  options.data["one"].indexOf(options.curVal["one"]);
        var curIndexOne =  _indexOne !== -1 ? _indexOne : 0;
        var dataLenOne = options.data["one"].length;
        var maxHeightOne = dataLenOne*liHeight;
        var ulHeightOne = maxHeightOne + boxH - liHeight;

        defaultPos('one',ulHeightOne,halfHeight);
        initScroll('one',curIndexOne,liHeight);

        var _indexTwo =  options.data["two"].indexOf(options.curVal["two"]);
        var curIndexTwo =  _indexTwo !== -1 ? _indexTwo : 0;
        var dataLenTwo = options.data["two"].length;
        var maxHeightTwo = dataLenTwo*liHeight;
        var ulHeightTwo = maxHeightTwo + boxH - liHeight;

        indexResult = {"one":curIndexOne,"two":curIndexTwo};
        defaultPos('two',ulHeightTwo,halfHeight);
        initScroll('two',curIndexTwo,liHeight);
    };

    var twoTimesStyle = function(){
        $('#bottom-module-cylinder-one').addClass('bottom-times-one');
        $('#bottom-module-cylinder-two').addClass('bottom-times-two');
    };

    var fourTimesStyle = function(){
        $('#bottom-module-cylinder-one').addClass('bottom-times-left');        
        $('#bottom-module-cylinder-two').addClass('bottom-times-right');
        $('#bottom-module-swicth-one').find('.bottom-module-choice').addClass('bottom-module-choice-left');
        $('#bottom-module-swicth-two').find('.bottom-module-choice').addClass('bottom-module-choice-right');
    };

    var defaultPos =function(idNum,ulHeight,halfHeight){
        $('#bottom-module-cylinder-'+idNum).css({
            'height' : ulHeight + 'px',
            'top' : halfHeight + 'px'
        });
    };

    var initScroll = function(idNum,curIndex,liHeight){

        scrollBox[idNum] = new iScroll("#bottom-module-wrapper-"+idNum,{
            scrollX: false,
            scrollY: true,
            momentum: false,
            snap: 'li',
            startY: -curIndex*liHeight,
            index: curIndex,
            liHeight: liHeight
        });
        scrollBox[idNum].on('scrollEnd', function(){
            indexResult[idNum] = Math.abs((this.y/liHeight));
        });
    };

    var getResult = function(el,func,data){

        return function(){
            var result = {};
            for(var i in indexResult){
                result[i] = data[i][indexResult[i]];
            }
            func(el,result);
        }
    };

    exports.init = init;

});
