define(function(require, exports, module) {
    var getData = require('./getData');

    var DDetails = function() {
        var _self = this;
        var moduleTpl = '<div class="sub" id="sub"></div>';
        _self.options = {};

        //添加dom
        function setHtml(container) {
            _self.options['container'] = $(container);

            //判断dom节点是否存在
            if (_self.options['container'].find('#sub').length === 0) {
                _self.options['container'].append(moduleTpl);
            }
            return this;
        }

        //添加数据
        function handleData(data) {
            var phoneWidth = parseInt(document.documentElement.clientWidth);
            var phoneHeight = parseInt(document.documentElement.clientHeight);
            var headTpl = '';
            var contTpl = '';
            var imgHeight = parseInt((phoneWidth / 640) * 460);
            var msName = !data['mcAlias'] ? data['mcName'] : data['mcAlias'];
            //详情头部
            headTpl += '<div class="g-header">' +
                '<div class="g-title">设备详情</div>' +
                '<div class="g-btn"><a class="g-left g-left-arr" id="goIndex" href="javascript:;">返回</a></div>' +
                '</div>';

            //详情内容
            contTpl += '<div class="cont">' +
                '<div class="img" style="height:'+imgHeight+'px"><img src="' + data.mcIcon + '" /></div>' +
                '<div class="dl">' +
                '<span class="dt">名<span style="visibility:hidden;">注</span>称：</span><span class="dd">' + data.mcName + '</span>' +
                '</div>' +
                '<div class="dl">' +
                '<span class="dt">型<span style="visibility:hidden;">注</span>号：</span><span class="dd">' + data.modelName + '</span>' +
                '</div>' +
                '<div class="dl">' +
                '<span class="dt">备注名：</span><span class="dd">' + msName + '</span>' +
                '</div>' +
                '</div>';

            _self.options['sub'] = $('#sub');
            _self.options['main'] = $('#main');
            _self.options['sub'].html(headTpl + contTpl);
            _self.options['goIndex'] = $('#goIndex');
            _self.options['goIndex'].on('click', function(e) {
                animate(false);
            });
            animate(true);
            return this;
        }

        //次级页动画
        function animate(type) {
            if (type) {
                setTimeout(function() {
                    $('.sub').css({
                        '-webkit-transform': 'translate3d(-100%, 0, 0)',
                        '-webkit-transition': '-webkit-transform 300ms ease-in-out'
                    });
                    $('.main').css({
                        '-webkit-transform': 'translate3d(-10%, 0, 0)',
                        '-webkit-transition': '-webkit-transform 300ms ease-in-out'
                    });
                }, 100);
            } else {
                setTimeout(function() {
                    $('.sub').css({
                        '-webkit-transform': 'translate3d(0, 0, 0)',
                        '-webkit-transition': '-webkit-transform 300ms ease-in-out'
                    });
                    $('.main').css({
                        '-webkit-transform': 'translate3d(0, 0, 0)',
                        '-webkit-transition': '-webkit-transform 300ms ease-in-out'
                    });
                }, 100);
            }
        }

        return {
            setHtml: setHtml,
            animate: animate,
            handleData: handleData
        }
    }

    return new DDetails;
});
