/* 中间部分内容加载 */
define(function(require, exports, module) {

    var XXTea = require("./util/encrypt/XXTea");

    var GetDatas = function() {
        var _self = this;
        _self.options = {};

        function extraFunc(name,func) {
            if (typeof(func) === 'function') {
                _self.options[name] = func;
            };
            return this;
        }

        //建立MQTT连接
        if (!isApp) {
            //            debug.log('MQTT in');
            /*var MQTTPackage = require('./mosquitto');
            var MQ = new MQTTPackage.Mosquitto;
            MQ.connect(MQTTHost, 3000);
            MQ.subscribe("/SH/" + mcId + "/S2H", 0);
            //MQTTPackage.handleMessage(centreWasher.centreDraw);
            //            debug.log('MQTT out');

            gFuncObj.mqtt = function() {
                var MQTTPackage = require('./mosquitto');
                var MQ = new MQTTPackage.Mosquitto;
                MQ.connect(MQTTHost, 3000);
                MQ.subscribe("/SH/" + mcId + "/S2H", 0);
            }*/
        }

        //报错提示
        function gErrorTips(str) {
            var html = '<div class="g-e-tips"><p>' + str + '</p></div>';
            if ($(".g-e-tips").length == 0) {
                $("body").append(html);
            } else {
                $(".g-e-tips").find("p").html(str);
            }
            setTimeout(function() {
                $(".g-e-tips").remove();
            }, 1000);
        }

        function gCallApi(api, method, isJson, param, callBack) {

            var params = JSON.stringify(param);
            $.ajax({
                type: "GET",
                url: api,
                dataType: "jsonp",
                data: param,
                async: false,
                timeout: 20000,
                success: function(data) {
                    callBack(data);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('textStatus='+textStatus);
                    //console.log('errorThrown='+errorThrown);
                    gErrorTips("网络连接不可用，请检查您的手机网络！");
                    if(typeof(_self.options['errCallBack']) === 'function'){
                        _self.options['errCallBack']();
                    }
                }
            });

        }

        function gModifyMcName(param, callBack) { //修改名称
            if (isApp) { //IOS,android客户端
                //客户端发送命令
                param = JSON.stringify(param);
                try {
                    javascript: android.js2java("modifyDeviceName", param);
                } catch (e) {}
            } else {
                var api = host + '/api/device/jsonp/modifyMcName';
                gCallApi(api, "POST", "0", param, callBack);
            }

        }

        function gExecuteCmd(param, callBack) { //控制设备
            var api = host + '/api/device/jsonp/executeCmd';
            gCallApi(api, "POST", "0", param, callBack);
        }

        function gQueryMcInfo(param, callBack) { //设备详情
            if (isApp) { //IOS,android客户端
                //客户端发送命令
                param = JSON.stringify(param);
                try {
                    javascript: android.js2java("getDeviceDetail", param);
                } catch (e) {}
            } else {
                var api = host + '/api/device/jsonp/queryMcInfo';
                gCallApi(api, "POST", "0", param, callBack);
            }
        }

        function gBindMc() { //分享控制权

        }

        function gUnbindMc(param, callBack) { //删除设备
            if (isApp) { //IOS,android客户端
                //客户端发送命令
                param = JSON.stringify(param);
                try {
                    javascript: android.js2java("deleteDevice", param);
                } catch (e) {}
            } else {
                if (param) {
                    param = JSON.stringify(param);

                    var signParam = userId + deviceId + mcId;
                    //console.log(signParam);
                    gEncrypt(userId, signParam, function(encrypt) {
                        var param = {
                            "userId": userId,
                            "deviceId": deviceId,
                            "mcId": mcId,
                            "sign": encrypt,
                            "modelType":modelType
                        };
                        var api = host + '/api/device/jsonp/unbindMc';
                        gCallApi(api, "POST", "0", param, callBack);
                    });

                }
            }


        }

        function gGetKey(param, callBack) { //获取命令加密key
            var api = host + '/api/device/jsonp/getKey';
            gCallApi(api, "GET", "0", param, callBack);
        }

        function gMcList(param, callBack) { //修改名称
            var api = host + '/api/device/jsonp/queryUserMcList';
            gCallApi(api, "POST", "0", param, callBack);

        }

        function gEncrypt(userId, param, callback) { //获取命令加密key

            if (!gKey) {
                var api = host + '/api/device/jsonp/getKey?userId=' + userId;
                gCallApi(api, "GET", "0", null, function(data) {
                    if (data.data) {
                        gKey = data.data;
                        var xxTea = new XXTea(gKey);
                        var encrypt = xxTea.encrypt(param);
                        callback(encrypt);
                    } else {
                        return null;
                    }
                });
            } else {
                var xxTea = new XXTea(gKey);
                var encrypt = xxTea.encrypt(param);
                callback(encrypt);
            }
        }

        //控制命令
        function getExecuteCmd(cmd, callBack) { //控制设备
            if (isApp) { //IOS,android客户端
                var str = JSON.stringify(cmd);
                var param = '{"newState":' + str + ',"oldState":' + gOldState + ',"cmd":' + str + '}';
                try {
                    javascript: android.js2java("cmd", param);
                } catch (e) {}
            } else {
                if (cmd) {
                    cmd = JSON.stringify(cmd);

                    var signParam = userId + cmd + mcId;
                    gEncrypt(userId, signParam, function(encrypt) {
                        var param = {
                            "userId": userId,
                            "mcId": mcId,
                            "cmd": cmd,
                            "deviceId": deviceId,
                            "modelType": modelType,
                            "sign": encrypt
                        };
                        var api = host + '/api/device/jsonp/executeCmd';
                        gCallApi(api, "POST", "0", param, callBack);
                    });

                }
            }
        }

        //获取分享码
        function gGenerateQRData(param, callBack) {
            var api = host + '/api/device/jsonp/generateQRData';
            gCallApi(api, "GET", "0", param, callBack);
        }

        //查询设备绑定用户数
        function gbindUserCount(param, callBack) {
            var api = host + '/api/device/jsonp/bindUserCount';
            gCallApi(api, "GET", "0", param, callBack);
        }

        //收回控制权
        function gUnbindOthers(param, callBack) {
            var api = host + '/api/device/jsonp/unbindOthers';
            gCallApi(api, "GET", "0", param, callBack);
        }

        return {
            gModifyMcName: gModifyMcName,
            gExecuteCmd: gExecuteCmd,
            gQueryMcInfo: gQueryMcInfo,
            gBindMc: gBindMc,
            gUnbindMc: gUnbindMc,
            gGetKey: gGetKey,
            getExecuteCmd: getExecuteCmd,
            gMcList: gMcList,
            gEncrypt: gEncrypt,
            gGenerateQRData: gGenerateQRData,
            gbindUserCount: gbindUserCount,
            gUnbindOthers: gUnbindOthers,
            extraFunc: extraFunc
        };

    };

    return new GetDatas;
});
