define(function(require, exports, module) {
/*
Copyright (c) 2012 cnsuning.com <14041567@cnsuning.com>
All rights reserved.


*/

/* Mosquitto MQTT Javascript/Websocket client */
/* Provides complete support for QoS 0. 
 * Will not cause an error on QoS 1/2 packets.
 */

 var MQTTPackage = function(){
 	var CONNECT = 0x10;
	var CONNACK = 0x20;
	var PUBLISH = 0x30;
	var PUBACK = 0x40;
	var PUBREC = 0x50;
	var PUBREL = 0x60;
	var PUBCOMP = 0x70;
	var SUBSCRIBE = 0x80;
	var SUBACK = 0x90;
	var UNSUBSCRIBE = 0xA0;
	var UNSUBACK = 0xB0;
	var PINGREQ = 0xC0;
	var PINGRESP = 0xD0;
	var DISCONNECT = 0xE0;

	var wap_syanc_mo_login_status=0;   //当前手机和盒子的连接状态，即MQQTT心跳决定  

	var timeInterval;

	/*
	 localStroage相关KEY
	 WAP_SYNC_TV_LOGIN_STATUS  盒子登陆状态KEY
	 WAP_SYNC_MO_LOGIN_STATUS  登陆登陆状态KEY
	 
	全局变量
		 
	*/


	function AB2S(buffer) {
		var binary = '';
		var bytes = new Uint8Array(buffer);
		var len = bytes.byteLength;
		for ( var i = 0; i < len; i++) {
			binary += String.fromCharCode(bytes[i]);
		}
		return binary;
	}

	

	//根据RC连接成功
	function showOnconnect(iCon){
		// 1 2 3 4 5 连接失败 	 0 成功。
		//console.log("===================showOnconnect==iCon========================"+iCon);
//		debug.log(iCon);
		switch(iCon){
				case 0:
				      //连接成功，全局连接变量赋值
					wap_syanc_mo_login_status='1';
					window.clearInterval(timeInterval);
					try{ //处理连接状态
						
						try{  
						         if(typeof(eval(showMoblieTvStatus))=="function"){
										showMoblieTvStatus(); 
						          }
						    }catch(e){
						        //alert("not function"); 
						   }  
						}catch(error){ 
							//console.log("异常处理完毕！");
						}finally{ 
						  //  console.log("异常处理完毕！"); 
						} 
						
					//console.log("连接成功wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
				  break;
				case 1:
				  //执行代码块 1
					wap_syanc_mo_login_status=0;
					//console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
				  break;
				case 2:
				 // 执行代码块 2
					wap_syanc_mo_login_status=0;
					//console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
					break;
				case 3:
					 // 执行代码块 2
					wap_syanc_mo_login_status=0;
					//console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
					break;
				case 4:
					 // 执行代码块 2
					wap_syanc_mo_login_status=0;
					//console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
					break;
				case 5:
					wap_syanc_mo_login_status=0;
					//console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
					 // 执行代码块 2
				  break;
				default:
					wap_syanc_mo_login_status=0;
				    //console.log("连接失败wap_syanc_mo_login_status="+wap_syanc_mo_login_status);
		}//END switch(iCon){
	}//END showOnconnect

	/*连接断开回调*/
	function showDisconnect(){
		
//		debug.log("showDisconnect");
		setTimeout(function(){gFuncObj.mqtt();}, 1000);
		
	}


	/*mqttobject*/
	function Mosquitto(){
		this.ws = null;
		this.onconnect = showOnconnect;
		this.ondisconnect = showDisconnect;
		this.onmessage = showMessage;
	}//end Mosquitto()

	Mosquitto.prototype = {
		mqtt_ping : function()
		{
			var buffer = new ArrayBuffer(2);
			var i8V = new Int8Array(buffer);
			i8V[0] = PINGREQ;
			i8V[1] = 0;
			if(this.ws.readyState == 1){
				this.ws.send(buffer);
			}else{
				this.queue(buffer);
			}
			setTimeout(function(_this){_this.mqtt_ping();}, 60000, this);
		},

		connect : function(url, keepalive){
//			debug.log("url"+url);
			this.url = url;
			this.keepalive = keepalive;
			this.mid = 1;
			this.out_queue = new Array();

			this.ws = new WebSocket(url, 'mqttv3.1');
			this.ws.binaryType = "arraybuffer";
			this.ws.onopen = this.ws_onopen;
			this.ws.onclose = this.ws_onclose;
			this.ws.onmessage = this.ws_onmessage;
			this.ws.m = this;
			this.ws.onerror = function(evt){
				//showTip("网络异常，请重试！");
//				debug.log("onerror");
			}
		},

		disconnect : function(){
			if(this.ws.readyState == 1){
				var buffer = new ArrayBuffer(2);
				var i8V = new Int8Array(buffer);

				i8V[0] = DISCONNECT;
				i8V[1] = 0;
				this.ws.send(buffer);
				this.ws.close();
			}
		},

		ws_onopen : function(evt) {
			
			//console.log("onconnect");
			var buffer = new ArrayBuffer(1+1+12+2+20);
			var i8V = new Int8Array(buffer);

			i=0;
			i8V[i++] = CONNECT;
			i8V[i++] = 12+2+20;
			i8V[i++] = 0;
			i8V[i++] = 6;
			str = "MQIsdp";
			for(var j=0; j<str.length; j++){
				i8V[i++] = str.charCodeAt(j);
			}
			i8V[i++] = 3;
			i8V[i++] = 2;
			i8V[i++] = 0;
			i8V[i++] = 60;
			i8V[i++] = 0;
			i8V[i++] = 20;
			
			var str = "mjsws/";
			for(var j=0; j<str.length; j++){
				i8V[i++] = str.charCodeAt(j);
			}
			var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
			for(var j=0; j<14; j++){
				i8V[i++] = chars.charCodeAt(Math.floor(Math.random()*chars.length));
			}

			if(this.send(buffer) === false){
//				debug.log("connecterror1");
			}
//			debug.log("connectsuccess1");
			//this.send(buffer);
			
			while(this.m.out_queue.length > 0){
				this.send(this.m.out_queue.pop());
			}
			setTimeout(function(_this){_this.mqtt_ping();}, 60000, this.m);
		},

		ws_onclose : function(evt) {
			//console.log("ws_onclose==>"+evt.data);
			if(this.m.ondisconnect){
				//console.log(evt.data);
				this.m.ondisconnect(evt.data);
			}
		},

		ws_onmessage : function(evt) {
			var i8V = new Int8Array(evt.data);
			buffer = evt.data;
			var q=0;
			while(i8V.length > 0 && q < 1000){
				q++;
				switch(i8V[0] & 0xF0){
					case CONNACK:
						var rl = i8V[1];
						var rc = i8V[2];
						if(this.m.onconnect){
							this.m.onconnect(rc);
						}
						buffer = buffer.slice(rl+2);
						i8V = new Int8Array(buffer);
						break;
					case PUBLISH:
						var i=1;
						var mult = 1;
						var rl = 0;
						var count = 0;
						var digit;
						var qos = (i8V[0] & 0x06) >> 1;
						var retain = (i8V[0] & 0x01);
						var mid = 0;
						do{
							count++;
							digit = i8V[i++];
							rl += (digit & 127)*mult;
							mult *= 128;
						}while((digit & 128) != 0);

						var topiclen = i8V[i++]*256 + i8V[i++];
						var atopic = buffer.slice(i, i+topiclen);
						i+=topiclen;
						var topic = AB2S(atopic);
						if(qos > 0){
							mid = i8V[i++]*256 + i8V[i++];
						}
						var apayload = buffer.slice(i, rl+count+1);
						var payload = AB2S(apayload);

						buffer = buffer.slice(rl+1+count);
						i8V = new Int8Array(buffer);

						if(this.m.onmessage){
							this.m.onmessage(topic, payload, qos, retain);
						}
						break;
					case PUBREC:
					case PUBREL:
					case PUBACK:
					case PUBCOMP:
					case SUBACK:
					case UNSUBACK:
					case PINGRESP:
						var rl = i8V[1];
						buffer = buffer.slice(rl+2);
						i8V = new Int8Array(buffer);
						break;
				}
			}
		},

		get_remaining_count : function(remaining_length)
		{
			if(remaining_length >= 0 && remaining_length < 128){
				return 1;
			}else if(remaining_length >= 128 && remaining_length < 16384){
				return 2;
			}else if(remaining_length >= 16384 && remaining_length < 2097152){
				return 3;
			}else if(remaining_length >= 2097152 && remaining_length < 268435456){
				return 4;
			}else{
				return -1;
			}
		},

		generate_mid : function()
		{
			var mid = this.mid;
			this.mid++;
			if(this.mid == 256) this.mid = 0;
			return mid;
		},

		queue : function(buffer)
		{
			this.out_queue.push(buffer);
		},

		send_cmd_with_mid : function(cmd, mid)
		{
			var buffer = new ArrayBuffer(4);
			var i8V = new Int8Array(buffer);
			i8V[0] = cmd;
			i8V[1] = 2;
			i8V[2] = mid%128;
			i8V[3] = mid/128;
			if(this.ws.readyState == 1){
				this.ws.send(buffer);
			}else{
				this.queue(buffer);
			}
		},

		unsubscribe : function(topic)
		{
			var rl = 2+2+topic.length;
			var remaining_count = this.get_remaining_count(rl);
			var buffer = new ArrayBuffer(1+remaining_count+rl);
			var i8V = new Int8Array(buffer);

			var i=0;
			i8V[i++] = UNSUBSCRIBE | 0x02;
			do{
				digit = Math.floor(rl % 128);
				rl = Math.floor(rl / 128);
				if(rl > 0){
					digit = digit | 0x80;
				}
				i8V[i++] = digit;
			}while(rl > 0);
			i8V[i++] = 0;
			i8V[i++] = this.generate_mid();
			i8V[i++] = 0;
			i8V[i++] = topic.length;
			for(var j=0; j<topic.length; j++){
				i8V[i++] = topic.charCodeAt(j);
			}

			if(this.ws.readyState == 1){
				this.ws.send(buffer);
			}else{
				this.queue(buffer);
			}
		},
		//订阅 
		subscribe : function(topic, qos)
		{
//			debug.log("topic"+topic);
			if(qos != 0){
				return 1;
			}
			var rl = 2+2+topic.length+1;
			var remaining_count = this.get_remaining_count(rl);
			var buffer = new ArrayBuffer(1+remaining_count+rl);
			var i8V = new Int8Array(buffer);

			var i=0;
			i8V[i++] = SUBSCRIBE | 0x02;
			do{
				digit = Math.floor(rl % 128);
				rl = Math.floor(rl / 128);
				if(rl > 0){
					digit = digit | 0x80;
				}
				i8V[i++] = digit;
			}while(rl > 0);
			i8V[i++] = 0;
			i8V[i++] = this.generate_mid();
			i8V[i++] = 0;
			i8V[i++] = topic.length;
			for(var j=0; j<topic.length; j++){
				i8V[i++] = topic.charCodeAt(j);
			}
			i8V[i++] = qos;

			if(this.ws.readyState == 1){
				this.ws.send(buffer);
			}else{
				this.queue(buffer);
			}
		},

		publish : function(topic, payload, qos, retain){
			if(qos != 0) return 1;
			var rl = 2+topic.length+payload.length;
			var remaining_count = this.get_remaining_count(rl);
			var buffer = new ArrayBuffer(1+remaining_count+rl);
			var i8V = new Int8Array(buffer);

			var i=0;
			retain = retain?1:0;
			i8V[i++] = PUBLISH | (qos<<1) | retain;
			do{
				digit = Math.floor(rl % 128);
				rl = Math.floor(rl / 128);
				if(rl > 0){
					digit = digit | 0x80;
				}
				i8V[i++] = digit;
			}while(rl > 0);
			i8V[i++] = 0;
			i8V[i++] = topic.length;
			for(var j=0; j<topic.length; j++){
				i8V[i++] = topic.charCodeAt(j);
			}
			for(var j=0; j<payload.length; j++){
				i8V[i++] = payload.charCodeAt(j);
			}

			if(this.ws.readyState == 1){
				this.ws.send(buffer);
			}else{
				this.queue(buffer);
			}
		}
	};    //Mosquitto.prototype = {

	//卸载页面时，显示调用断开websockt连接，mosquitto对象清理
	window.onunload=function(){
		
	    //mqtt对象是否存在
		if(mosquitto!=null){  
	       //console.log("mosquitto is   not null");
	       
		   //断开websokcet连接
		   mosquitto.disconnect();
		   mosquitto=null;
		   
		} //end  if(mosquitto!=null){  
	};//end  window.onunload


	return {
		Mosquitto : Mosquitto
    };
 };

 return new MQTTPackage;


});