define(function(require, exports, module) {
    var getData = require('./getData');
    var MENU = function() {
        var _self = this;
        var $menu;
        var $content = $('#content');
        var tpl = '<div class="g-menuList" id="menuList">' +
            '<ul>' +
            '<li id="editName" name="panel_none_xgmc"><a href="javascript:;" class="edit-name">修改名称</a></li>' +
            '<li id="shareDevices" name="panel_none_fxkzq"><a href="javascript:;" class="share-devices">分享控制权</a></li>' +
            '<li id="devicesDetails" name="panel_none_sbxq"><a page="deviceDetails" href="javascript:;" class="devices-details">设备详情</a></li>' +
            '<li id="removeDevices" name="panel_none_scsb"><a href="javascript:;" class="remove-devices">删除设备</a></li>' +
            '</ul>' +
            '</div>';
        _self.options = {};

        //添加dom
        function setHtml(container) {
            _self.options['container'] = $(container);
            if (_self.options['container'].find('.g-menuList').length === 0) {
                _self.options['container'].append(tpl);
                _self.options['menuList'] = _self.options.container.find('.g-menuList');
                // _self.options['editName'] = _self.options.container.find('#editName');
                // _self.options['shareDevices'] = _self.options.container.find('#shareDevices');
                // _self.options['devicesDetails'] = _self.options.container.find('#devicesDetails');
                // _self.options['removeDevices'] = _self.options.container.find('#removeDevices');
            }
            $menu = $('#menu');
            bindEvent();
            $('body').append('<input type="hidden" id="resourceType" value="smartHome">'); //bi添加smartHome变量
        }

        //监听
        function bindEvent() {
            /*_self.options.menuList.find('li').on('click', function(event) {
                if (_self.options.flag) {
                    getAlert($(this));
                    try {
                        sa.click.sendDatasIndex(this); //数据上报
                    } catch (e) {}
                }
            });*/

            //弹出菜单
            $menu.on('click', function(e) {
                var type = $(this).attr('data-load');
                if (!type) {
                    show($(this));
                } else {
                    hide($(this));
                }
                e.stopPropagation();
            });

            //收回菜单
            $content.on('click', function(e) {
                var type = $menu.attr('data-load');
                if (type) {
                    hide($menu);
                }
            });
        }

        //显示菜单
        function show(e) {
            if (_self.options.menuList) {
                _self.options.menuList.addClass('menu-show').removeClass('menu-hide');
                e.attr('data-load', '0');
                _self.options['flag'] = true;
            }
        };

        //隐藏菜单
        function hide(e) {
            _self.options.menuList.addClass('menu-hide');
            e.removeAttr('data-load');
            _self.options['flag'] = false;
        };

        //加载JS
        function getScript(url, callback) {
            var head = document.getElementsByTagName('head')[0];
            var script = document.createElement('script');
            var es = document.getElementsByTagName('script');
            var scriptList = url.split('/');
            var fileName = scriptList[scriptList.length - 1];
            var flag = false;
            script.setAttribute('type', 'text/javascript');
            script.setAttribute('src', url);

            //判断js是否存在
            for (var i = 0; i < es.length; i++) {
                if (es[i]['src'].indexOf(fileName) != -1) {
                    flag = true;
                }
            }

            //callback
            if (!flag) {
                head.appendChild(script);
                script.onload = function() {
                    if (typeof callback === 'function') {
                        callback();
                    }
                }
            } else {
                if (typeof callback === 'function') {
                    callback();
                }
            }
        }

        //yyyyMMddHHmmssSSS
        function getDate() {
            var date = new Date();
            var y = date.getFullYear(); //年
            var M = date.getMonth() + 1; //月
            var d = date.getDate(); //日
            var H = date.getHours(); //小时
            var m = date.getMinutes(); //分
            var s = date.getSeconds(); //秒
            var S = date.getMilliseconds(); //毫秒
            var dbl00 = function(num) {
                return num < 10 ? '0' + num : num;
            }
            M = dbl00(M);
            d = dbl00(d);
            H = dbl00(H);
            m = dbl00(m);
            s = dbl00(s);
            if (S < 100 && S > 9) {
                S = '0' + S;
            } else if (S < 10) {
                S = '00' + S;
            }
            return y + M + d + H + m + s + S;
        }

        //获取sign
        /*var signStr;
        function getSign(callback){
            if(!signStr){
                var signParam = {
                    "userId": userId,
                    "deviceId": deviceId,
                    "mcId": mcId
                };
                signParam = JSON.stringify(signParam);
                getData.gGetSign('?params='+signParam,function(result){
                    if(result.ret === "0" && callback && typeof(callback) === "function"){
                        signStr = result.data;
                        callback(signStr);
                    }
                });
            }else{
                if (callback && typeof(callback) === "function") {
                    callback(signStr);
                }
            }

        }*/

        //报错提示
        function gErrorTips(str) {
            var html = '<div class="g-e-tips"><p>' + str + '</p></div>';
            if ($(".g-e-tips").length == 0) {
                $("body").append(html);
            } else {
                $(".g-e-tips").find("p").html(str);
            }
            setTimeout(function() {
                $(".g-e-tips").remove();
            }, 1000);
        }



        //菜单列表Handler
        function getAlert(e) {
            var e = e[0];
            require.async(['./util/alert/sweetalert.min', '../css/sweetalert.css'], function(sweetalert) {
                switch (e.id) {
                    case 'editName': //修改名称
                        var gMcName = gFuncObj.gMcName;
                        sweetalert({
                            title: "修改名称",
                            type: "input",
                            showCancelButton: true,
                            closeOnConfirm: true,
                            customClass: 'editName',
                            inputClass: 'iEditName',
                            inputClear: true,
                            inputValue: gMcName,
                            inputPlaceholder: "请输入设备名称"
                        }, function(inputValue) {
                            if (inputValue === false) return false;
                            if (inputValue === "") {
                                gFuncObj.gErrorTips("设备名称不能为空!");
                                return false;
                            }

                            gFuncObj.gMcName = inputValue;
                            $('#mcName').html(gFuncObj.gMcName);
                            var msg = "设备名称修改成功！";
                            gFuncObj.gErrorTips(msg);
                        });
                        break;
                    case 'shareDevices': //分享控制权
                        if (false/*isApp*/) {
                            var param = '{"mcId":' + modId + '}';
                            try {
                                //alert("主动请求状态2");
                                //alert(java2js);
                                javascript: android.js2java("shareControl", param);
                            } catch (e) {}

                        } else {
                            require.async('./util/qrcode/qrcode', function(QRCODE) {
                                var signParam = userId + modelId + mcId;
                                
                                var picCode = window.location.href;
                                var botTpl = "分享控制权";
                                var qrcodeHtml = '<div id="qrcode" class="qrcode"></div>';

                                sweetalert({
                                    title: "分享控制权",
                                    text: qrcodeHtml + botTpl,
                                    html: true
                                });

                                QRCODE.qrcode($('#' + $(qrcodeHtml)[0].id), {
                                    width: 305,
                                    height: 305,
                                    correctLevel: QRCODE.QRErrorCorrectLevel.L,
                                    background: "#ffffff",
                                    foreground: "#000000",
                                    text: picCode
                                });

                                //监听取消绑定
                                $('#unbindBtn').on('click', function() {
                                    getData.gUnbindOthers(paramUnbind, function(result) {
                                        gFuncObj.gErrorTips(result.msg);
                                        $(".sweet-alert .confirm").trigger("click");
                                    })


                                });
                            });
                        }
                        break;
                    case 'devicesDetails': //设备详情
                        require.async('./details', function(DDetails) {
                            DDetails.setHtml('#content').handleData(window.cachedDeviceInfo);
                        });
                        // var param = {
                        //     "userId": userId,
                        //     "mcId": mcId
                        // };
                        // getData.gQueryMcInfo(param, function(result) {
                        //     var data = result.data;
                        //     if (result.ret === "0") {
                        //         require.async('./details', function(DDetails) {
                        //             DDetails.setHtml('#content').handleData(data);
                        //         });
                        //     } else {
                        //         swal(result.msg);
                        //     }
                        // });

                        //history.pushState(null, '', '#details');
                        localStorage.setItem("title", "details");

                        break;
                    case 'removeDevices': //删除设备
                        sweetalert({
                            title: "确定删除设备吗？",
                            showCancelButton: true,
                            confirmButtonText: "确定",
                            cancelButtonText: "取消",
                            closeOnConfirm: true
                        }, function() {
                            gFuncObj.gErrorTips("删除成功！");
                            setTimeout(function() {
                                location.href = "../../home.html";
                            }, 1200);
                            // if (isApp) {
                            //     var param = {
                            //         "mcId": mcId,
                            //         "modelType": "1"
                            //     };
                            //     getData.gUnbindMc(param, function(data) {
                            //         //console.log(data);
                            //         var msg;
                            //         if (data.ret === "0") {
                            //             msg = "删除成功！";
                            //         } else {
                            //             msg = "删除失败！";
                            //         }
                            //         gFuncObj.gErrorTips(msg);
                            //     });
                            // } else {
                                // var param = {
                                //     "userId": userId,
                                //     "deviceId": deviceId,
                                //     "mcId": mcId
                                // };

                                // getData.gUnbindMc(param, function(data) {
                                //     //console.log(data)
                                //     var msg;
                                //     if (data.ret === "0") {
                                //         gFuncObj.gErrorTips("删除成功！");
                                //         setTimeout(function() {
                                //             location.href = "../../home.html?userId=" + userId;
                                //         }, 1200);
                                //     } else {
                                //         gFuncObj.gErrorTips("删除失败！");
                                //     }
                                // });
                            // }

                            //上报解绑数据
                            // getScript('../../base/js/da_opt.js', function() {
                            //     //key 参数名对应modelId，userId，mcId
                            //     //现客户端上报命
                            //     var key = 'deviceModel,account,deviceId,time,resourceType';
                            //     var values = modelId + ',' + userId + ',' + mcId + ',' + getDate() + ',smartHome';
                            //     try {
                            //         if (saCustomDataUtil && typeof(saCustomDataUtil) == "object") {
                            //             saCustomDataUtil.sendData('unbind', key, values);
                            //         }
                            //     } catch (e) {}
                            // });

                        });
                        break;
                    default:
                        break;
                }
            });
        }

        return {
            setHtml: setHtml,
            show: show,
            hide: hide
        };

    };

    return MENU;
});
