define(function(require, exports, module) {
    require('../css/m_menu.css');
    var bottomTime = require('../../../base/js/bottomTime');
    var bottomLayer = require('../../../base/js/bottomLayer');
    var getData = require('../../../base/js/getData');
    var colorSelector = require('./colorSelector');

    var disabled = true;        //开关灯状态 true 关灯 false 开灯
    var timeText = '定时开灯';
    var timeText2 = '开灯时间';
    var timeType = null;
    var timeType2 = null;
    var curMenuId = null;       //当前色温+亮度
    var timeOn = 0;
    var timeOff = 0;
    var oldHours = null;
    var oldMinutes = null;

    var tNow = null;
    var date = null;
    var times = null;

    var timeIntervalS = null;
    var timeIntervalMs = null;

    var onlineStatus = null; //在线 离线状态
    var runTime = null;

    //第一次上报颜色后设置为 false 等第一次推送成功之后才设置成 true 方便后面亮度的推送维持状态
    var isOK = true;
    var newBright = null;

    //预期值
    var isPost = true;

    var $bMenu = $('#b-menu');
    var $bTip = $('#b-tip');
    var $item = null;
    var $tMenu = null;

    //test数据
    /*var stateObj1 = {
        'deviceSwitch' : '1',    // 1 0开关机
        'bright' : '80',         // 灯亮度 0~255
        'colorTemp' : '#33333',  // 灯色温 000000~ffffff
        'timeInterval' : '1200',    // 0~60000ms 炫彩调节时间间隔
        'mode' : '1',            // 1普通 2炫彩 模式
        'timeOn' : '100',        // 0~86400s 定时开
        'timeOff' : '0'        // 0~86400s 定时关
    };*/

    //创建dom节点并绑定事件
    var zero = function(){
        render();
        //disable();
        //bindTouch();
        bindItem();
        bindTime();
        bindColorful();
    };

    //初始化
    var init = function(stateObj){
        window.cachedstateObj = stateObj;
        window.cachedInit = init;
        //预期值
        if(!isPost){
            var deviceSwitch = stateObj.deviceSwitch;
            var onlineStatus = stateObj.onlineStatus;
            disabled = (deviceSwitch === '1' && onlineStatus === '1') ? false : true;
            if(disabled){
                colorSelector.getSwitch(false);
                isPost = true;
                isSetHum = true;
            }          
        }

        tNow = new Date();
        initTime(stateObj);

        
        if(!isOK){
            colorUpdate();
            return;
        }
        initStatus(stateObj);
        
        refresh();
        colorUpdate();
    };
    
    var colorArray = ["FF9300","FFFFFF","FF5D00","4800FF","0048FF"];
    var colorInder = 0;
    var timer ;
    var changeBg = function(){
        //$('.pic-color').css({'background-color':"#"+colorArray[colorInder]});
        $('.pic-color')
        .removeClass("xc1")
        .removeClass("xc2")
        .removeClass("xc3")
        .removeClass("xc4")
        .removeClass("xc5")
        .addClass("xc"+(colorInder+1))
        colorInder++;
        colorInder = colorInder % 4;
        var step = cachedstateObj.timeInterval - 0 + 500; 
       
        timer = setTimeout(function(){
            changeBg();
        },step);
    }
    var colorUpdate = function(){
        var sid = $(".b-list.justify .b-on").eq(0).attr("data-sid");
        
        if( sid &&　sid != '2' ){
            clearTimeout(timer);
            $(".pic-color").removeClass("xc");
            var color = sid.split("|")[0];
            $('.pic-color').css({'background-color':"#"+color});

        }
        if( sid &&　sid == '2' ){
             $('.pic-color')[0].style.background = '';
             $(".pic-color").addClass("xc");
            var colorInder = 0;
            clearTimeout(timer);
            var step = cachedstateObj.timeInterval - 0 + 500; 
            timer = setTimeout(function(){
                changeBg();
            },step);

        }
    }


    //初始化时间
    var initTime = function(stateObj){
        var deviceSwitch = stateObj.deviceSwitch;
        var timeIntervalStr = stateObj.timeInterval;
        timeInterval = parseInt(timeIntervalStr);
        var mode = stateObj.mode;
        onlineStatus = stateObj.onlineStatus;
        runTime = stateObj.runTime || '0';

        disabled = (deviceSwitch === '1' && onlineStatus === '1') ? false : true;
        timeText = '定时';

        timeOn = parseInt(stateObj.timeOn) || 0;
        timeOff = parseInt(stateObj.timeOff) || 0;

        //关灯定时、开灯定时确认
        if(timeOn !== 0){
            timeType2 = 'timeOn';
            timeText2 = '开灯时间';
        }else if(timeOff !== 0){
            timeType2 = 'timeOff';
            timeText2 = '关灯时间';
        }else{
            timeType2 = null;
        }

        if(timeType2 === null){
            times = null;
            $bTipTime.addClass('hide');
            if($('#bottom-layer').length){
                bottomLayer.hide();
            };
        }else{
            getTimes();
            $bTipTime.removeClass('hide');
        }

        if(!disabled && mode === '2' && (timeIntervalStr === '0' || !timeIntervalStr)){
            postAction('timeInterval', '200');
        }else if(!disabled && mode === '2' && timeIntervalStr && timeIntervalStr !== '0'){
            $bTipColorful.removeClass('hide');
            timeIntervalS = parseInt(timeInterval/1000);
            timeIntervalS = timeIntervalS > 10 ? (timeIntervalS + '') : ('0' + timeIntervalS);
            timeIntervalMs = timeInterval%1000 + '';
            $bTipSeconds.text(timeIntervalS);
            $bTipMsec.text(timeIntervalMs);
        }else{
            $bTipColorful.addClass('hide');
        }

        if(timeType2 !== null && mode === '2' && timeIntervalStr && timeIntervalStr !== '0'){
            $bTip.removeClass('center').addClass('justify');
        }else{
            $bTip.removeClass('justify').addClass('center');
        }


    };

    //转换定时时间格式
    var getTimes = function(){
        var delay = timeType2 === 'timeOff' ? timeOff : timeOn;
        var tDate1 = tNow.getDate();
        var tTime = runTime === '0' ? (tNow*1 + delay*1000) : runTime;
        var tFuture = new Date(tTime);
        var tDate2 = tFuture.getDate();

        var hours = tFuture.getHours();
        var minutes = tFuture.getMinutes();
        hours = hours < 10 ? ('0' + hours) : hours;
        minutes = minutes < 10 ? ('0' + minutes) : minutes;

        date = tDate1 === tDate2 ? '今天' : '明天';
        times = hours + ':' + minutes;

        var times2 = tDate1 === tDate2 ? times : '明天 ' + times;
        $bTipText.text(timeText2);
        $bTipTimes.text(times2);

    };

    //初始化状态
    var initStatus = function(stateObj){

        var bright = stateObj.bright;
        var colorTemp = stateObj.colorTemp;
        var mode = stateObj.mode;

        //mode 1 普通模式 2 炫彩模式
        curMenuId = mode === '2' ? '2' : (colorTemp + '|' + bright);
    };

    //刷新dom
    var refresh = function(){
        disabled ? disable() : enable();
        if(timeOn === 0 && timeOff === 0){
            $tMenu.removeClass('b-time-on');
        }else{
            $tMenu.addClass('b-time-on');
        }
    };

    //关灯
    var disable = function(){
        $bMenu.addClass('b-disabled');
        $('.b-on').removeClass('b-on');
    };

    //开灯
    var enable = function(){
        $bMenu.removeClass('b-disabled');
        $('.b-on').removeClass('b-on');
        $(".b-item[data-sid = '"+ curMenuId +"']").addClass('b-on');
    };

    //渲染dom
    var render = function(){
        //状态显示
        $bTip.append('<div class="b-tip-time hide">'+
                        '<span class="b-tip-text"></span>:<span class="b-tip-times"></span>'+
                     '</div>'+
                     '<a href="javascript:;" class="b-tip-colorful hide">'+
                        '炫彩时间:<span class="b-tip-seconds"></span>s<span class="b-tip-msec"></span>ms<span class="b-tip-right">></span>'+
                     '</a>');

        var $menu = $(
                    '<ul class="b-list justify">'+
                            '<li class="b-item" data-sid="FF9300|70" name="panel_none_zndp_mrms">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">默认</p>'+
                            '</li>'+
                            '<li class="b-item" data-sid="FFFFFF|255" name="panel_none_zndp_rgms">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">日光</p>'+
                           '</li>'+
                            '<li class="b-item" data-sid="FF5D00|255" name="panel_none_zndp_ksms">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">看书</p>'+
                            '</li>'+
                            '<li class="b-item" data-sid="4800FF|30" name="panel_none_zndp_lmms">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">浪漫</p>'+
                            '</li>'+
                    '</ul>'+
                    '<ul class="b-list justify">'+
                            '<li class="b-item" data-sid="0048FF|20" name="panel_none_zndp_yyms">'+
                               '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">影院</p>'+
                            '</li>'+
                            '<li class="b-item" data-sid="2" name="panel_none_zndp_xcms">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">炫彩</p>'+
                            '</li>'+
                            '<li class="b-item b-time" name="panel_none_zndp_dskd">'+
                                '<a class="b-circle center" href="javascript:;">'+
                                    '<span class="b-icon"></span>'+
                                '</a>'+
                                '<p class="b-style">定时</p>'+
                            '</li>'+
                            '<li class="justify-fix"></li>'+
                    '</ul>'
                    );

        $bMenu.append($menu);
        $item = $('.b-item');
        $tMenu = $('.b-time');

        $bTipText = $('.b-tip-text');
        $bTipTime = $('.b-tip-time');
        $bTipTimes = $('.b-tip-times');

        $bTipSeconds = $('.b-tip-seconds');
        $bTipMsec = $('.b-tip-msec');
        $bTipColorful = $('.b-tip-colorful');

    };

    //预期值修改
    var rollBack = function(){
        if(disabled){
            colorSelector.getSwitch(false);
        }       
        isPost = true;
        isSetHum = true; //释放选择条
        isOK = true;
    };

    //按钮事件回滚回调函数
    var itemBack = function(){
        $('.b-on').removeClass('b-on');
        $(".b-item[data-sid = '"+ curMenuId +"']").addClass('b-on');
        //预期值修改
        rollBack();
    };

    var timerPost = null; 
    var okFunc = function(){
        //第二次上报亮度
        clearTimeout(timerPost);
        timerPost = setTimeout(function(){
            //postAction('bright', newBright, rollBack, rollBack);
        },800);
    };

    //绑定灯光模式按钮事件
    var bindItem = function() {
        $item.on('click', function(){
            var that = $(this);
            if(!disabled && !that.hasClass('b-on') && !that.hasClass('b-time')){
                $('.b-on').removeClass('b-on');
                that.addClass('b-on');

                var _sid = that.attr('data-sid')+'';

                //炫彩模式
                if(_sid === '2'){
                    //预期值修改
                    colorSelector.getSwitch(false);
                    isSetHum = true; //恢复选择条
                    //postAction('mode', '2', itemBack);
                    cachedstateObj.mode = '2';
                    init(cachedstateObj);
                    return;
                }
                

                var _sidArr = _sid.split('|');
                var _colorTemp =  _sidArr[0];
                var _bright = _sidArr[1];

                cachedstateObj.mode = '1';
                cachedstateObj.colorTemp = _colorTemp;
                cachedstateObj.bright = _bright;
                

                newBright = _bright;

                //灯光模式数据上报
                isOK = false;
                //预期值修改
                isPost = false;
                isSetHum = false; //禁用选择条
                colorSelector.init(_bright, _colorTemp).getSwitch(true); //设置选择条预期状态

                init(cachedstateObj);
                //第一次上报颜色
                //postAction('colorTemp', _colorTemp, itemBack, okFunc);

                try {
                //    sa.click.sendDatasIndex(this); //数据上报
                } catch (e) {}
            }
        });
    };

    var tBack = function(){
        $tMenu.toggleClass('b-time-on');
    };

    //设置定时回调函数
    var tCallback = function(el,data){
        //console.log(data);

        if(timeType === 'timeOff' && disabled){
            gErrorTips('设备已关灯');
            return;
        }
        if(timeType === 'timeOn' && !disabled){
            gErrorTips('设备已开灯');
            return;
        }

        $tMenu.addClass('b-time-on');

        var tOld = new Date();
        var oldHours = tOld.getHours();
        var oldMinutes = tOld.getMinutes();
        var oldSeconds = tOld.getSeconds();

        var oldTime = oldHours*3600 + oldMinutes*60 + oldSeconds;    
        var newTime = parseInt(data.one)*3600 + parseInt(data.two)*60;

        var newT = null;
        if(newTime >= oldTime){
            newT = tOld;
        }else{
            var tomorrow = tOld*1 + (86400 + newTime - oldTime)*1000;
            newT = new Date(tomorrow);
        }
        var newYear = newT.getFullYear();
        var newMonth = newT.getMonth() + 1;
        newMonth = newMonth < 10 ? '0' + newMonth : newMonth;
        var newDate = newT.getDate();
        newDate = newDate < 10 ? '0' + newDate : newDate;
        var time = newYear + '-' + newMonth + '-' + newDate + ' ' + data.one + ':' + data.two + ':00';

        var newSeconds = Math.round( ( new Date(time).getTime() - new Date().getTime() ) /1000 ) + "";
         if( timeType == 'timeOff'){
            cachedstateObj.timeOff = newSeconds ;
        }else if( timeType === 'timeOn' ){
            cachedstateObj.timeOn = newSeconds;
        }
        init(cachedstateObj);
        
        //上报定时数据
        //postAction(timeType,time,tBack);
    };

    //报错提示
    function gErrorTips(str) {
        var html = '<div class="g-e-tips"><p>' + str + '</p></div>';
        if ($(".g-e-tips").length == 0) {
            $("body").append(html);
        } else {
            $(".g-e-tips").find("p").html(str);
        }
        setTimeout(function() {
            $(".g-e-tips").remove();
        }, 1000);
    };


    var timeBack = function(){
        $tMenu.toggleClass('b-time-on');
    };

    var closeTime = function(){
        if(timeType2 === 'timeOff' && disabled){
            gErrorTips('设备已关灯');
            return;
        }
        if(timeType2 === 'timeOn' && !disabled){
            gErrorTips('设备已开灯');
            return;
        }
        $tMenu.removeClass('b-time-on');
        if( timeType2 == 'timeOff'){
            cachedstateObj.timeOff = 0 ;
        }else if( timeType2 === 'timeOn' ){
            cachedstateObj.timeOn = 0;
        }
        init(cachedstateObj);

        //上报取消定时数据
        //postAction(timeType2,'0',tBack);
    };

    //绑定定时按钮事件
    var bindTime = function() {
        $tMenu.on('click', function(){
            if(onlineStatus === '0'){
                gFuncObj.gErrorTips("设备已离线！");
                return;
            }
            var that = $(this);

            //定时
            if(timeType2 === null){
                //that.addClass('b-time-on');
                //gErrorTips('设备已开灯');
                var tOld = new Date();
                oldHours = tOld.getHours();
                oldMinutes = tOld.getMinutes() + 1;
                oldHours = oldHours < 10 ? ('0' + oldHours) : (oldHours + '');
                oldMinutes = oldMinutes < 10 ? ('0' + oldMinutes) : (oldMinutes + '');
                timeType = 'timeOn';

                //定时类型选择
                var extra = '<div class="b-on-off center"><label class="bulb-radio bulb-radio-checked bulb-on">'
                            +'<i class="bulb-radio-icon"></i><span class="bulb-radio-text">开灯</span></label>'
                            +'<label class="bulb-radio bulb-off"><i class="bulb-radio-icon"></i><span class="bulb-radio-text">关灯</span></label></div>';

                bottomTime.init({
                    title: timeText,
                    cancelFun: true,
                    confirmFun: tCallback,
                    type: 2, //选择器种类
                    curVal: {
                        "one": oldHours,
                        "two": oldMinutes
                    },
                    unit: {
                        "one": null,
                        "two": null
                    },
                    data: null,
                    el: null,
                    extra: extra 
                });

                bindRadio();

            }else{
                var html = '<div class="b-timing-wraper"><div class="b-timing">'+ times +'</div>'+
                       '<p class="b-date"><span class="b-text-color">'+ timeText2 +'</span><span class="b-date-color">'+ date +'</span></p></div>';
                bottomLayer.init({
                    title : timeText,
                    html : html,
                    rightText : '关闭定时',
                    cancelFun : true,
                    confirmFun : closeTime
                });
            }
        });
    };

    var bindRadio = function(){
        $('.bulb-radio').on('click',function(){
            var that = $(this);
            that.addClass('bulb-radio-checked').siblings().removeClass('bulb-radio-checked');
            timeType = that.index() === 0 ? 'timeOn' : 'timeOff';
        });
    };

    //上报炫彩时间间隔
    var setColorful = function(el,data){
        //console.log(data);
        var itv = parseInt(data.one)*1000 + parseInt(data.two) + '';
        cachedstateObj.timeInterval = itv;
        init(cachedstateObj);
        //postAction('timeInterval', itv);
    };

    //炫彩模式选择ms
    var bindColorful = function(){

        var data = {
            'one' : ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59","60"],
            'two' : ['100','200','300','400','500','600','700','800','900']
        };

        $bTipColorful.on('click', function(){
            if(onlineStatus === '0'){
                gFuncObj.gErrorTips("设备已离线！");
                return;
            }
            bottomTime.init({
                title: '时间间隔',
                cancelFun: true,
                confirmFun: setColorful,
                type: 4, //选择器种类
                curVal: {
                    "one": timeIntervalS,
                    "two": timeIntervalMs
                },
                unit: {
                    "one": 's',
                    "two": 'ms'
                },
                data: data,
                el: null
            });
        });
    };

    var errCallBack = function(){
        rollBack();
    };
    getData = getData.extraFunc('errCallBack',errCallBack);

    //提交控制中心
    var postAction = function(state,value,backFunc,okFunc) {
        //console.log(state,value);
        var cmd= {"modId":modId,"stateSet":[{"state": state,"value": value}]};

        getData.getExecuteCmd(cmd ,function(data){
            if(data.ret === "0"){
                //数据提交成功
                if(typeof(okFunc) === 'function'){
                    okFunc();
                }
            }else{
                //数据提交异常
                gFuncObj.gErrorTips("服务器处理异常！");
                if(typeof(backFunc) === 'function'){
                    backFunc();
                }
            }
        });

    };

    zero();
    exports.init = init;

    //test
    /*init(stateObj1);
    setTimeout(function(){
        init(stateObj2);
    }, 2000);*/

});